tabloc_options = {
  get : function(key) {
    var value = localStorage[key];
    if(value == undefined){
      switch(key){
        case "fg_foreground": return false;
        case "pos_relative":  return false;
        case "ex_inpagelink": return true;
        case "ex_javascript": return true;
        case "ex_formsubmit": return false;
        case "ic_background": return "locked.png";
        case "ic_foreground": return "locked2.png";
        case "ic_disabled": return "tabloc.png";
        case "auto_url": return "";
      }
    }else if(value == "false"){
      return false;
    }else{
      return value;
    }
  },

  set : function(key, value) {
    localStorage[key] = value;
  },

  saveOption : function(id) {
    var input = document.getElementById(id);
    tabloc_options.set(id, input.checked);
  },

  saveOptions : function() {
    tabloc_options.saveOption("fg_foreground");
    tabloc_options.saveOption("pos_relative");
    tabloc_options.saveOption("ex_inpagelink");
    tabloc_options.saveOption("ex_javascript");
    tabloc_options.saveOption("ex_formsubmit");
    tabloc_options.set("auto_url", document.getElementById("auto_url").value);
    tabloc_options.set("ic_background",
        document.getElementById("ic_background").src);
    tabloc_options.set("ic_foreground",
        document.getElementById("ic_foreground").src);
    tabloc_options.set("ic_disabled",
        document.getElementById("ic_disabled").src);

    var status = document.getElementById("status");
    status.innerHTML = chrome.i18n.getMessage("options_save_done");
    status.style.display = "block";
    setTimeout(function() { status.style.display = "none"; }, 1000);
  },

  restoreLabel : function(id, msgname) {
    if(!msgname) {
      msgname = id;
    }
    var tag = document.getElementById(id);
    tag.innerHTML = chrome.i18n.getMessage(msgname);
  },

  restoreLabels : function() {
    tabloc_options.restoreLabel("options_title");
    tabloc_options.restoreLabel("options_head_foreground");
    tabloc_options.restoreLabel("options_fg_background");
    tabloc_options.restoreLabel("options_fg_foreground");
    tabloc_options.restoreLabel("options_head_position");
    tabloc_options.restoreLabel("options_pos_last");
    tabloc_options.restoreLabel("options_pos_relative");
    tabloc_options.restoreLabel("options_head_exclude");
    tabloc_options.restoreLabel("options_ex_inpagelink");
    tabloc_options.restoreLabel("options_ex_javascript");
    tabloc_options.restoreLabel("options_ex_formsubmit");
    tabloc_options.restoreLabel("options_head_autolock");
    tabloc_options.restoreLabel("options_auto_url");
    tabloc_options.restoreLabel("options_head_icon");
    tabloc_options.restoreLabel("options_ic_background");
    tabloc_options.restoreLabel("options_ic_foreground");
    tabloc_options.restoreLabel("options_ic_disabled");
    tabloc_options.restoreLabel("options_ic_background_change",
        "options_ic_change");
    tabloc_options.restoreLabel("options_ic_foreground_change",
        "options_ic_change");
    tabloc_options.restoreLabel("options_ic_disabled_change",
        "options_ic_change");
    tabloc_options.restoreLabel("options_ic_background_restore",
        "options_ic_restore");
    tabloc_options.restoreLabel("options_ic_foreground_restore",
        "options_ic_restore");
    tabloc_options.restoreLabel("options_ic_disabled_restore",
        "options_ic_restore");
    tabloc_options.restoreLabel("options_save");
  },

  restoreOption : function(id) {
    var input = document.getElementById(id);
    input.checked = tabloc_options.get(id);
  },

  restoreOptions : function() {
    var fg_foreground = tabloc_options.get("fg_foreground");
    document.getElementById("fg_background").checked = !fg_foreground;
    document.getElementById("fg_foreground").checked = fg_foreground;

    var pos_relative = tabloc_options.get("pos_relative");
    document.getElementById("pos_last").checked     = !pos_relative;
    document.getElementById("pos_relative").checked = pos_relative;

    tabloc_options.restoreOption("ex_inpagelink");
    tabloc_options.restoreOption("ex_javascript");
    tabloc_options.restoreOption("ex_formsubmit");

    document.getElementById("auto_url").value = tabloc_options.get("auto_url");

    document.getElementById("ic_background").src =
        tabloc_options.get("ic_background");
    document.getElementById("ic_foreground").src =
        tabloc_options.get("ic_foreground");
    document.getElementById("ic_disabled").src =
        tabloc_options.get("ic_disabled");
  },

  loadImage : function(id) {
    var file_element = document.getElementById("file_" + id);
    if (!file_element || !(file_element.value) || !file_element.files ||
        !file_element.files[0]){
      return;
    }
    var file_reader = new FileReader();
    file_reader.addEventListener('load', function() {
      document.getElementById(id).setAttribute("src", file_reader.result);
    });
    file_reader.readAsDataURL(file_element.files[0]);
  }
};

window.addEventListener("load", function(){
  tabloc_options.restoreLabels();
  tabloc_options.restoreOptions();
  document.getElementById("options_save").
      addEventListener("click", tabloc_options.saveOptions);
  document.getElementById("file_ic_background").
      addEventListener("change", function(){
        tabloc_options.loadImage("ic_background");
      });
  document.getElementById("file_ic_foreground").
      addEventListener("change", function(){
        tabloc_options.loadImage("ic_foreground");
      });
  document.getElementById("file_ic_disabled").
      addEventListener("change", function(){
        tabloc_options.loadImage("ic_disabled");
      });
  document.getElementById("options_ic_background_restore").
      addEventListener("click", function(){
        document.getElementById("file_ic_background").value = '';
        document.getElementById("ic_background").src = "locked.png";
      });
  document.getElementById("options_ic_foreground_restore").
      addEventListener("click", function(){
        document.getElementById("file_ic_foreground").value = '';
        document.getElementById("ic_foreground").src = "locked2.png";
      });
  document.getElementById("options_ic_disabled_restore").
      addEventListener("click", function(){
        document.getElementById("file_ic_disabled").value = '';
        document.getElementById("ic_disabled").src = "tabloc.png";
      });
});
